package com.ekexiu.portal.dao;

import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.util.PageQueryResult;

import com.ekexiu.portal.po.Consult;
import com.ekexiu.portal.pojo.EditProfessor;

@DAO
public abstract class ConsultDao {
	@Insert
	public abstract int insert(Connection con, Consult consult) throws SQLException;
	
	@Update
	public abstract int update(Connection con, Consult consult) throws SQLException;
	
	@UpdateWith
	@From(Consult.class)
	public abstract int updateFinishTime(Connection con, String consultId, @Set String finishTime) throws SQLException;
	
	public int updateRevoveryTime(Connection con,String consultId) throws SQLException{
        int _m_1 = 1;
        String sql ="UPDATE CONSULT SET REVOVERY_TIME= TO_CHAR(NOW(),'YYYYMMDDHH24MISS') WHERE CONSULT_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(_m_1++,consultId);
            return ps.executeUpdate();
        }finally{
            try{ps.close();}catch(Exception _m_2){}
        }
    }
	
	@SelectOne
	@Nullable
	public abstract Consult query(Connection con, String consultId) throws SQLException;
	
	public PageQueryResult<Consult> queryPagePro(Connection con, String professorId, int consultStatus, int timeType, int sortType, int pageSize, int pageNo) throws SQLException{
		PageQueryResult<Consult> queryResult = new PageQueryResult<Consult>();
		StringBuilder sql = new StringBuilder();
		sql.append(" WHERE CONSULT.PROFESSOR_ID = ? ");
		if(0 != consultStatus) {
			sql.append(" AND CONSULT_STATUS = ? ");
		}
		StringBuilder whereSql = sql;
		sql = new StringBuilder();
		sql.append("SELECT COUNT(1) FROM CONSULT");
		if (whereSql.length() > 0) {
			sql.append(whereSql);
		}
		PreparedStatement ps = con.prepareStatement(sql.toString());
		int paramIndex = 1;
		int totalSize = 0;
		try {
			ps.setString(paramIndex++, professorId);
			if(0 != consultStatus){
				ps.setInt(paramIndex++, consultStatus);
			}
			queryResult.setPageSize(pageSize);
			ResultSet resultSet = ps.executeQuery();
			try {
				resultSet.next();
				totalSize = resultSet.getInt(1);
			} finally {
				try {
					resultSet.close();
				} catch (Exception _m_6) {
				}
			}
		} finally {
			try {
				ps.close();
			} catch (Exception _m_7) {
			}
		}
		queryResult.setTotal(totalSize);
		if (0 == totalSize) {
			queryResult.setPageNo(1);
			queryResult.setData(Collections.<Consult> emptyList());
			return queryResult;
		}
		paramIndex = 1;
		if (1 == pageNo) {
			queryResult.setPageNo(1);
			sql = new StringBuilder();
			sql.append(" SELECT CONSULT_ID,CONSULT_TYPE,CONSULT_TITLE,CONSULT_CONTANT,CONSULT.PROFESSOR_ID,CONSULTANT_ID,CONSULT_STATUS,FINISH_TIME,ASSESS_STATUS,ASSESS_STAR,ASSESS_CONTANT,ASSESS_TIME,THANKS_STATUS,THANKS_MONEY,THANKS_TIME,REVOVERY_TIME,CONSULT.CREATE_TIME,PROFESSOR.NAME,PROFESSOR.DEPARTMENT,PROFESSOR.TITLE,PROFESSOR.ADDRESS,ORGANIZATION.NAME FROM CONSULT LEFT JOIN PROFESSOR ON CONSULT.CONSULTANT_ID = PROFESSOR.ID LEFT JOIN ORGANIZATION ON PROFESSOR.ORG_ID = ORGANIZATION.ID ");
			if (whereSql.length() > 0) {
				sql.append(whereSql);
			}
			if(0 == timeType) {
				sql.append(" ORDER BY CONSULT.CREATE_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(1 == timeType) {
				sql.append(" ORDER BY REVOVERY_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(2 == timeType) {
				sql.append(" ORDER BY FINISH_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}
			sql.append(" LIMIT ").append(pageSize);
		} else {
			int _pageSize = totalSize / pageSize;
			if (totalSize % pageSize != 0) {
				++_pageSize;
			}
			if (pageNo > _pageSize) {
				pageNo = _pageSize;
			}
			queryResult.setPageNo(pageNo);
			--pageNo;
			int _m_10 = (pageNo * pageSize);
			sql = new StringBuilder();
			sql.append(" SELECT CONSULT_ID,CONSULT_TYPE,CONSULT_TITLE,CONSULT_CONTANT,CONSULT.PROFESSOR_ID,CONSULTANT_ID,CONSULT_STATUS,FINISH_TIME,ASSESS_STATUS,ASSESS_STAR,ASSESS_CONTANT,ASSESS_TIME,THANKS_STATUS,THANKS_MONEY,THANKS_TIME,REVOVERY_TIME,CONSULT.CREATE_TIME,PROFESSOR.NAME,PROFESSOR.DEPARTMENT,PROFESSOR.TITLE,PROFESSOR.ADDRESS,ORGANIZATION.NAME FROM CONSULT LEFT JOIN PROFESSOR ON CONSULT.CONSULTANT_ID = PROFESSOR.ID LEFT JOIN ORGANIZATION ON PROFESSOR.ORG_ID = ORGANIZATION.ID ");
			if (whereSql.length() > 0) {
				sql.append(whereSql);
			}
			if(0 == timeType) {
				sql.append(" ORDER BY CONSULT.CREATE_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(1 == timeType) {
				sql.append(" ORDER BY REVOVERY_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(2 == timeType) {
				sql.append(" ORDER BY FINISH_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}
			sql.append(" LIMIT ").append(pageSize).append(" OFFSET ").append(_m_10);
		}
		ps = con.prepareStatement(sql.toString());
		try {
			ps.setString(paramIndex++, professorId);
			if(0 != consultStatus){
				ps.setInt(paramIndex++, consultStatus);
			}
			ResultSet rs = ps.executeQuery();
			try {
				List<Consult> _m_11 = new ArrayList<Consult>();
				queryResult.setData(_m_11);
				while (rs.next()) {
					Consult consult = new Consult();
					consult.setConsultId(rs.getString(1));
					consult.setConsultType(rs.getString(2));
					consult.setConsultTitle(rs.getString(3));
					consult.setConsultContant(rs.getString(4));
					consult.setProfessorId(rs.getString(5));
					EditProfessor professor = new EditProfessor();
					professor.setId(rs.getString(6));
					Integer m1 = rs.getInt(7);
					if (rs.wasNull()) {
						m1 = null;
					}
					consult.setConsultStatus(m1);
					String m2 = rs.getString(8);
					if (rs.wasNull()) {
						m2 = null;
					}
					consult.setFinishTime(m2);
					Integer m3 = rs.getInt(9);
					if (rs.wasNull()) {
						m3 = null;
					}
					consult.setAssessStatus(m3);
//					Integer m4 = rs.getInt(10);
//					if (rs.wasNull()) {
//						System.out.println("1");
//						m4 = null;
//					}
//					consult.setAssessStar(m4);
					consult.setAssessStar(rs.getInt(10));
					String m5 = rs.getString(11);
					if (rs.wasNull()) {
						m5 = null;
					}
					consult.setAssessContant(m5);
					String m6 = rs.getString(12);
					if (rs.wasNull()) {
						m6 = null;
					}
					consult.setAssessTime(m6);
					Integer m7 = rs.getInt(13);
					if (rs.wasNull()) {
						m7 = null;
					}
					consult.setThanksStatus(m7);
					BigDecimal m8 = rs.getBigDecimal(14);
					if (rs.wasNull()) {
						m8 = null;
					}
					consult.setThanksMoney(m8);
					String m9 = rs.getString(15);
					if (rs.wasNull()) {
						m9 = null;
					}
					consult.setThanksTime(m9);
					consult.setRevoveryTime(rs.getString(16));
					consult.setCreateTime(rs.getString(17));
					professor.setName(rs.getString(18));
					professor.setDepartment(rs.getString(19));
					professor.setTitle(rs.getString(20));
					String m10 = rs.getString(21);
					if (rs.wasNull()) {
						m10 = null;
					}
					professor.setAddress(m10);
					professor.setOrgName(rs.getString(22));
					consult.setProfessor(professor);
					_m_11.add(consult);
				}
				return queryResult;
			} finally {
				try {
					rs.close();
				} catch (Exception _m_17) {
				}
			}
		} finally {
			try {
				ps.close();
			} catch (Exception _m_18) {
			}
		}
	}
	
	public PageQueryResult<Consult> queryPageCon(Connection con, String consultantId, int consultStatus, int timeType, int sortType, int pageSize, int pageNo) throws SQLException{
		PageQueryResult<Consult> queryResult = new PageQueryResult<Consult>();
		StringBuilder sql = new StringBuilder();
		sql.append(" WHERE CONSULT.CONSULTANT_ID = ? ");
		if(0 != consultStatus) {
			sql.append(" AND CONSULT_STATUS = ? ");
		}
		StringBuilder whereSql = sql;
		sql = new StringBuilder();
		sql.append("SELECT COUNT(1) FROM CONSULT");
		if (whereSql.length() > 0) {
			sql.append(whereSql);
		}
		PreparedStatement ps = con.prepareStatement(sql.toString());
		int paramIndex = 1;
		int totalSize = 0;
		try {
			ps.setString(paramIndex++, consultantId);
			if(0 != consultStatus){
				ps.setInt(paramIndex++, consultStatus);
			}
			queryResult.setPageSize(pageSize);
			ResultSet resultSet = ps.executeQuery();
			try {
				resultSet.next();
				totalSize = resultSet.getInt(1);
			} finally {
				try {
					resultSet.close();
				} catch (Exception _m_6) {
				}
			}
		} finally {
			try {
				ps.close();
			} catch (Exception _m_7) {
			}
		}
		queryResult.setTotal(totalSize);
		if (0 == totalSize) {
			queryResult.setPageNo(1);
			queryResult.setData(Collections.<Consult> emptyList());
			return queryResult;
		}
		paramIndex = 1;
		if (1 == pageNo) {
			queryResult.setPageNo(1);
			sql = new StringBuilder();
			sql.append(" SELECT CONSULT_ID,CONSULT_TYPE,CONSULT_TITLE,CONSULT_CONTANT,CONSULT.PROFESSOR_ID,CONSULTANT_ID,CONSULT_STATUS,FINISH_TIME,ASSESS_STATUS,ASSESS_STAR,ASSESS_CONTANT,ASSESS_TIME,THANKS_STATUS,THANKS_MONEY,THANKS_TIME,REVOVERY_TIME,CONSULT.CREATE_TIME,PROFESSOR.NAME,PROFESSOR.DEPARTMENT,PROFESSOR.TITLE,PROFESSOR.ADDRESS,ORGANIZATION.NAME FROM CONSULT LEFT JOIN PROFESSOR ON CONSULT.PROFESSOR_ID = PROFESSOR.ID LEFT JOIN ORGANIZATION ON PROFESSOR.ORG_ID = ORGANIZATION.ID ");
			if (whereSql.length() > 0) {
				sql.append(whereSql);
			}
			if(0 == timeType) {
				sql.append(" ORDER BY CONSULT.CREATE_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(1 == timeType) {
				sql.append(" ORDER BY REVOVERY_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(2 == timeType) {
				sql.append(" ORDER BY FINISH_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}
			sql.append(" LIMIT ").append(pageSize);
		} else {
			int _pageSize = totalSize / pageSize;
			if (totalSize % pageSize != 0) {
				++_pageSize;
			}
			if (pageNo > _pageSize) {
				pageNo = _pageSize;
			}
			queryResult.setPageNo(pageNo);
			--pageNo;
			int _m_10 = (pageNo * pageSize);
			sql = new StringBuilder();
			sql.append(" SELECT CONSULT_ID,CONSULT_TYPE,CONSULT_TITLE,CONSULT_CONTANT,CONSULT.PROFESSOR_ID,CONSULTANT_ID,CONSULT_STATUS,FINISH_TIME,ASSESS_STATUS,ASSESS_STAR,ASSESS_CONTANT,ASSESS_TIME,THANKS_STATUS,THANKS_MONEY,THANKS_TIME,REVOVERY_TIME,CONSULT.CREATE_TIME,PROFESSOR.NAME,PROFESSOR.DEPARTMENT,PROFESSOR.TITLE,PROFESSOR.ADDRESS,ORGANIZATION.NAME FROM CONSULT LEFT JOIN PROFESSOR ON CONSULT.PROFESSOR_ID = PROFESSOR.ID LEFT JOIN ORGANIZATION ON PROFESSOR.ORG_ID = ORGANIZATION.ID ");
			if (whereSql.length() > 0) {
				sql.append(whereSql);
			}
			if(0 == timeType) {
				sql.append(" ORDER BY CONSULT.CREATE_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(1 == timeType) {
				sql.append(" ORDER BY REVOVERY_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(2 == timeType) {
				sql.append(" ORDER BY FINISH_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}
			sql.append(" LIMIT ").append(pageSize).append(" OFFSET ").append(_m_10);
		}
		ps = con.prepareStatement(sql.toString());
		try {
			ps.setString(paramIndex++, consultantId);
			if(0 != consultStatus){
				ps.setInt(paramIndex++, consultStatus);
			}
			ResultSet rs = ps.executeQuery();
			try {
				List<Consult> _m_11 = new ArrayList<Consult>();
				queryResult.setData(_m_11);
				while (rs.next()) {
					Consult consult = new Consult();
					consult.setConsultId(rs.getString(1));
					consult.setConsultType(rs.getString(2));
					consult.setConsultTitle(rs.getString(3));
					consult.setConsultContant(rs.getString(4));
					EditProfessor professor = new EditProfessor();
					professor.setId(rs.getString(5));
					consult.setConsultantId(rs.getString(6));
					Integer m1 = rs.getInt(7);
					if (rs.wasNull()) {
						m1 = null;
					}
					consult.setConsultStatus(m1);
					String m2 = rs.getString(8);
					if (rs.wasNull()) {
						m2 = null;
					}
					consult.setFinishTime(m2);
					Integer m3 = rs.getInt(9);
					if (rs.wasNull()) {
						m3 = null;
					}
					consult.setAssessStatus(m3);
					consult.setAssessStar(rs.getInt(10));
					String m5 = rs.getString(11);
					if (rs.wasNull()) {
						m5 = null;
					}
					consult.setAssessContant(m5);
					String m6 = rs.getString(12);
					if (rs.wasNull()) {
						m6 = null;
					}
					consult.setAssessTime(m6);
					Integer m7 = rs.getInt(13);
					if (rs.wasNull()) {
						m7 = null;
					}
					consult.setThanksStatus(m7);
					BigDecimal m8 = rs.getBigDecimal(14);
					if (rs.wasNull()) {
						m8 = null;
					}
					consult.setThanksMoney(m8);
					String m9 = rs.getString(15);
					if (rs.wasNull()) {
						m9 = null;
					}
					consult.setThanksTime(m9);
					consult.setRevoveryTime(rs.getString(16));
					consult.setCreateTime(rs.getString(17));
					professor.setName(rs.getString(18));
					professor.setDepartment(rs.getString(19));
					professor.setTitle(rs.getString(20));
					String m10 = rs.getString(21);
					if (rs.wasNull()) {
						m10 = null;
					}
					professor.setAddress(m10);
					professor.setOrgName(rs.getString(22));
					consult.setProfessor(professor);
					_m_11.add(consult);
				}
				return queryResult;
			} finally {
				try {
					rs.close();
				} catch (Exception _m_17) {
				}
			}
		} finally {
			try {
				ps.close();
			} catch (Exception _m_18) {
			}
		}
	}
	
}
