package com.ekexiu.portal.service;

import java.sql.Connection;
import java.sql.SQLException;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.operate.Put;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.util.PageQueryResult;
import org.jfw.util.StringUtil;

import com.ekexiu.portal.dao.ConsultDao;
import com.ekexiu.portal.po.Consult;

@Path("/consult")
public class ConsultService {
	@Autowrie
	private ConsultDao consultDao;
	public ConsultDao getConsultDao() {
		return consultDao;
	}
	public void setConsultDao(ConsultDao consultDao) {
		this.consultDao = consultDao;
	}
	
	@Post
	@Path
	public String insert(@JdbcConn(true) Connection con, Consult consult) throws SQLException {
		String consultId = StringUtil.buildUUID();
		consult.setConsultId(consultId);
		this.consultDao.insert(con, consult);
		return consultId;
	}
	
	@Put
	@Path
	public void update(@JdbcConn(true) Connection con, Consult consult) throws SQLException {
		this.consultDao.update(con, consult);
	}
	
	@Post
	@Path("/finishTime")
	public void updateFinishTime(@JdbcConn(true) Connection con, String consultId, String finishTime) throws SQLException {
		Consult consult = this.consultDao.query(con, consultId);
		if(null == consult.getFinishTime()){
			this.consultDao.updateFinishTime(con, consultId, finishTime);
		}
	}
	
	@Get
	@Path("/{consultId}")
	public Consult query(@JdbcConn Connection con, @PathVar String consultId) throws SQLException {
		return this.consultDao.query(con, consultId);
	}
	
	@Get
	@Path("/pqpro")
	public PageQueryResult<Consult> queryPagePro(@JdbcConn Connection con, String professorId, 
			@DefaultValue("0") int consultStatus, @DefaultValue("0") int timeType, @DefaultValue("0") int sortType, 
			@DefaultValue("5") int pageSize, @DefaultValue("1") int pageNo) throws SQLException {
		return this.consultDao.queryPagePro(con, professorId, consultStatus, timeType, sortType, pageSize, pageNo);
	}	
	
	@Get
	@Path("/pqcon")
	public PageQueryResult<Consult> queryPageCon(@JdbcConn Connection con, String consultantId, 
			@DefaultValue("0") int consultStatus, @DefaultValue("0") int timeType, @DefaultValue("0") int sortType, 
			@DefaultValue("5") int pageSize, @DefaultValue("1") int pageNo) throws SQLException {
		return this.consultDao.queryPageCon(con, consultantId, consultStatus, timeType, sortType, pageSize, pageNo);
	}
	
}
